/** @file counter_model.h
 * This file contains counter model class description.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/model.hpp>

#include <counter_coverage.h>
#include <counter_msg.h>

namespace cpptesk {
namespace examples {
namespace counter {

MODEL(Counter) {
public:
    Counter();
    virtual ~Counter();

    DECLARE_INPUT(iface1);
    DECLARE_OUTPUT(iface2);

    virtual bool isIface1Ready() const;

    DECLARE_STIMULUS(inc);
    DECLARE_REACTION(read_result);

    void inc_counter(void);
    int get_value(void);

    CounterCoverage coverage;
    void refresh_coverage(void);
protected:
    int counter;
};

}}}

