/** @file counter_scen.h
 * This file contains scenario class description.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <counter_media.h>

#include <ts/scenario.hpp>

using namespace cpptesk::ts;
using namespace cpptesk::hw;
using namespace cpptesk::tracer;

namespace cpptesk {
namespace examples {
namespace counter {

SCENARIO(CounterScenario)
{
public:
    typedef IntAbcCtx Ctx;

    virtual bool init(int argc, char ** argv);
    virtual void finish();

    bool scen_inc(Ctx& ctx);

    std::string get_state_counter();

    CounterScenario(void);
    virtual ~CounterScenario(void);

protected:
    CounterMediator dut;
};

class ExampleScenario : public CounterScenario
{
public:
    ExampleScenario();
    virtual ~ExampleScenario();
};

}}}
